=== debian/changelog ===
ldc (1:1.11.0-1ubuntu1) cosmic; urgency=medium

  * Use the long-double default on ppc64el.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 07 Sep 2018 18:04:13 +0200

ldc (1:1.11.0-1) unstable; urgency=medium

  * New upstream version: 1.11.0
    - Now supports arm64, more testing is needed though (Closes: #791976)
  * Drop bootstrap-pic-default.patch: Applied upstream
  * Refresh & adjust patches
  * Record packaged ltsmaster commit in d/ldc-ltsmaster-commit.txt
  * Document new-release packaging workflow
  * Bump standards version: No changes needed
  * Update library package name
  * Update package descriptions
  * Build using LLVM 6 (Closes: #904278)

 -- Matthias Klumpp <mak@debian.org>  Sun, 19 Aug 2018 18:38:14 +0200

ldc (1:1.8.0-3) unstable; urgency=medium

  * Pass -V to dh_makeshlibs
  * Update maintainer address to tracker.d.o
  * bootstrap-no-zlib-embed.patch: Adjust to fix FTBFS with recent cmake

 -- Matthias Klumpp <mak@debian.org>  Sun, 06 May 2018 22:46:52 +0200

ldc (1:1.8.0-2) unstable; urgency=medium

  * Make libphobos2-ldc-shared-dev conflict with old libphobos2-ldc-dev

 -- Matthias Klumpp <mak@debian.org>  Sat, 31 Mar 2018 17:14:06 +0200
